diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/examples/wireless/wifi-eht-network.cc ns-3.42/examples/wireless/wifi-eht-network.cc
--- ns-3.41/examples/wireless/wifi-eht-network.cc	2024-02-09 14:44:07.841789700 -0800
+++ ns-3.42/examples/wireless/wifi-eht-network.cc	2024-05-29 15:29:46.912073100 -0700
@@ -31,7 +31,6 @@
 #include "ns3/on-off-helper.h"
 #include "ns3/packet-sink-helper.h"
 #include "ns3/packet-sink.h"
-#include "ns3/rng-seed-manager.h"
 #include "ns3/spectrum-wifi-helper.h"
 #include "ns3/ssid.h"
 #include "ns3/string.h"
@@ -110,7 +109,7 @@
                       const ApplicationContainer& serverApp,
                       uint32_t payloadSize,
                       Time tputInterval,
-                      double simulationTime)
+                      Time simulationTime)
 {
     auto newRxBytes = GetRxBytes(udp, serverApp, payloadSize);
     Time now = Simulator::Now();
@@ -127,9 +126,9 @@
 
     rxBytes.swap(newRxBytes);
 
-    if (now < Seconds(simulationTime) - NanoSeconds(1))
+    if (now < (simulationTime - NanoSeconds(1)))
     {
-        Simulator::Schedule(Min(tputInterval, Seconds(simulationTime) - now - NanoSeconds(1)),
+        Simulator::Schedule(Min(tputInterval, simulationTime - now - NanoSeconds(1)),
                             &PrintIntermediateTput,
                             rxBytes,
                             udp,
@@ -152,9 +151,11 @@
     uint16_t transitionDelayUsec{128};
     uint16_t channelSwitchDelayUsec{100};
     bool switchAuxPhy{true};
-    double simulationTime{10}; // seconds
-    double distance{1.0};      // meters
-    double frequency{5};       // whether the first link operates in the 2.4, 5 or 6 GHz
+    uint16_t auxPhyChWidth{20};
+    bool auxPhyTxCapable{true};
+    Time simulationTime{"10s"};
+    double distance{1.0}; // meters
+    double frequency{5};  // whether the first link operates in the 2.4, 5 or 6 GHz
     double frequency2{0}; // whether the second link operates in the 2.4, 5 or 6 GHz (0 means no
                           // second link exists)
     double frequency3{
@@ -199,13 +200,19 @@
                  "Whether Aux PHY should switch channel to operate on the link on which "
                  "the Main PHY was operating before moving to the link of the Aux PHY. ",
                  switchAuxPhy);
+    cmd.AddValue("emlsrAuxChWidth",
+                 "The maximum channel width (MHz) supported by Aux PHYs.",
+                 auxPhyChWidth);
+    cmd.AddValue("emlsrAuxTxCapable",
+                 "Whether Aux PHYs are capable of transmitting.",
+                 auxPhyTxCapable);
     cmd.AddValue("channelSwitchDelay",
                  "The PHY channel switch delay in microseconds",
                  channelSwitchDelayUsec);
     cmd.AddValue("distance",
                  "Distance in meters between the station and the access point",
                  distance);
-    cmd.AddValue("simulationTime", "Simulation time in seconds", simulationTime);
+    cmd.AddValue("simulationTime", "Simulation time", simulationTime);
     cmd.AddValue("udp", "UDP if set to 1, TCP otherwise", udp);
     cmd.AddValue("downlink",
                  "Generate downlink flows if set to 1, uplink flows otherwise",
@@ -214,7 +221,7 @@
     cmd.AddValue("mpduBufferSize",
                  "Size (in number of MPDUs) of the BlockAck buffer",
                  mpduBufferSize);
-    cmd.AddValue("nStations", "Number of non-AP HE stations", nStations);
+    cmd.AddValue("nStations", "Number of non-AP EHT stations", nStations);
     cmd.AddValue("dlAckType",
                  "Ack sequence type for DL OFDMA (NO-OFDMA, ACK-SU-FORMAT, MU-BAR, AGGR-MU-BAR)",
                  dlAckSeqType);
@@ -288,9 +295,10 @@
         double previous = 0;
         uint16_t maxChannelWidth =
             (frequency != 2.4 && frequency2 != 2.4 && frequency3 != 2.4) ? 160 : 40;
+        int minGi = enableUlOfdma ? 1600 : 800;
         for (int channelWidth = 20; channelWidth <= maxChannelWidth;) // MHz
         {
-            for (int gi = 3200; gi >= 800;) // Nanoseconds
+            for (int gi = 3200; gi >= minGi;) // Nanoseconds
             {
                 if (!udp)
                 {
@@ -318,8 +326,7 @@
                 if (frequency2 == frequency || frequency3 == frequency ||
                     (frequency3 != 0 && frequency3 == frequency2))
                 {
-                    std::cout << "Frequency values must be unique!" << std::endl;
-                    return 0;
+                    NS_FATAL_ERROR("Frequency values must be unique!");
                 }
 
                 for (auto freq : {frequency, frequency2, frequency3})
@@ -370,8 +377,7 @@
                     }
                     else
                     {
-                        std::cout << "Wrong frequency value!" << std::endl;
-                        return 0;
+                        NS_FATAL_ERROR("Wrong frequency value!");
                     }
                     nLinks++;
                 }
@@ -402,7 +408,11 @@
                                     "EmlsrTransitionDelay",
                                     TimeValue(MicroSeconds(transitionDelayUsec)),
                                     "SwitchAuxPhy",
-                                    BooleanValue(switchAuxPhy));
+                                    BooleanValue(switchAuxPhy),
+                                    "AuxPhyTxCapable",
+                                    BooleanValue(auxPhyTxCapable),
+                                    "AuxPhyChannelWidth",
+                                    UintegerValue(auxPhyChWidth));
                 for (uint8_t linkId = 0; linkId < nLinks; linkId++)
                 {
                     phy.Set(linkId, "ChannelSettings", StringValue(channelStr[linkId]));
@@ -431,8 +441,6 @@
                             SsidValue(ssid));
                 apDevice = wifi.Install(phy, mac, wifiApNode);
 
-                RngSeedManager::SetSeed(1);
-                RngSeedManager::SetRun(1);
                 int64_t streamNumber = 100;
                 streamNumber += wifi.AssignStreams(apDevice, streamNumber);
                 streamNumber += wifi.AssignStreams(staDevices, streamNumber);
@@ -461,6 +469,8 @@
                 InternetStackHelper stack;
                 stack.Install(wifiApNode);
                 stack.Install(wifiStaNodes);
+                streamNumber += stack.AssignStreams(wifiApNode, streamNumber);
+                streamNumber += stack.AssignStreams(wifiStaNodes, streamNumber);
 
                 Ipv4AddressHelper address;
                 address.SetBase("192.168.1.0", "255.255.255.0");
@@ -482,24 +492,31 @@
                     clientNodes.Add(downlink ? wifiApNode.Get(0) : wifiStaNodes.Get(i));
                 }
 
+                const auto maxLoad =
+                    nLinks * EhtPhy::GetDataRate(mcs, channelWidth, gi, 1) / nStations;
                 if (udp)
                 {
                     // UDP flow
                     uint16_t port = 9;
                     UdpServerHelper server(port);
                     serverApp = server.Install(serverNodes.get());
+                    streamNumber += server.AssignStreams(serverNodes.get(), streamNumber);
+
                     serverApp.Start(Seconds(0.0));
-                    serverApp.Stop(Seconds(simulationTime + 1));
+                    serverApp.Stop(simulationTime + Seconds(1.0));
+                    const auto packetInterval = payloadSize * 8.0 / maxLoad;
 
                     for (std::size_t i = 0; i < nStations; i++)
                     {
                         UdpClientHelper client(serverInterfaces.GetAddress(i), port);
                         client.SetAttribute("MaxPackets", UintegerValue(4294967295U));
-                        client.SetAttribute("Interval", TimeValue(Time("0.00001"))); // packets/s
+                        client.SetAttribute("Interval", TimeValue(Seconds(packetInterval)));
                         client.SetAttribute("PacketSize", UintegerValue(payloadSize));
                         ApplicationContainer clientApp = client.Install(clientNodes.Get(i));
+                        streamNumber += client.AssignStreams(clientNodes.Get(i), streamNumber);
+
                         clientApp.Start(Seconds(1.0));
-                        clientApp.Stop(Seconds(simulationTime + 1));
+                        clientApp.Stop(simulationTime + Seconds(1.0));
                     }
                 }
                 else
@@ -509,8 +526,10 @@
                     Address localAddress(InetSocketAddress(Ipv4Address::GetAny(), port));
                     PacketSinkHelper packetSinkHelper("ns3::TcpSocketFactory", localAddress);
                     serverApp = packetSinkHelper.Install(serverNodes.get());
+                    streamNumber += packetSinkHelper.AssignStreams(serverNodes.get(), streamNumber);
+
                     serverApp.Start(Seconds(0.0));
-                    serverApp.Stop(Seconds(simulationTime + 1));
+                    serverApp.Stop(simulationTime + Seconds(1.0));
 
                     for (std::size_t i = 0; i < nStations; i++)
                     {
@@ -520,13 +539,15 @@
                         onoff.SetAttribute("OffTime",
                                            StringValue("ns3::ConstantRandomVariable[Constant=0]"));
                         onoff.SetAttribute("PacketSize", UintegerValue(payloadSize));
-                        onoff.SetAttribute("DataRate", DataRateValue(1000000000)); // bit/s
+                        onoff.SetAttribute("DataRate", DataRateValue(maxLoad));
                         AddressValue remoteAddress(
                             InetSocketAddress(serverInterfaces.GetAddress(i), port));
                         onoff.SetAttribute("Remote", remoteAddress);
                         ApplicationContainer clientApp = onoff.Install(clientNodes.Get(i));
+                        streamNumber += onoff.AssignStreams(clientNodes.Get(i), streamNumber);
+
                         clientApp.Start(Seconds(1.0));
-                        clientApp.Stop(Seconds(simulationTime + 1));
+                        clientApp.Stop(simulationTime + Seconds(1.0));
                     }
                 }
 
@@ -542,20 +563,20 @@
                                         serverApp,
                                         payloadSize,
                                         tputInterval,
-                                        simulationTime + 1);
+                                        simulationTime + Seconds(1.0));
                 }
 
-                Simulator::Stop(Seconds(simulationTime + 1));
+                Simulator::Stop(simulationTime + Seconds(1.0));
                 Simulator::Run();
 
                 // When multiple stations are used, there are chances that association requests
                 // collide and hence the throughput may be lower than expected. Therefore, we relax
                 // the check that the throughput cannot decrease by introducing a scaling factor (or
                 // tolerance)
-                double tolerance = 0.10;
+                auto tolerance = 0.10;
                 cumulRxBytes = GetRxBytes(udp, serverApp, payloadSize);
-                uint64_t rxBytes = std::accumulate(cumulRxBytes.cbegin(), cumulRxBytes.cend(), 0);
-                double throughput = (rxBytes * 8) / (simulationTime * 1000000.0); // Mbit/s
+                auto rxBytes = std::accumulate(cumulRxBytes.cbegin(), cumulRxBytes.cend(), 0.0);
+                auto throughput = (rxBytes * 8) / simulationTime.GetMicroSeconds(); // Mbit/s
 
                 Simulator::Destroy();
 
@@ -563,7 +584,7 @@
                           << throughput << " Mbit/s" << std::endl;
 
                 // test first element
-                if (mcs == 0 && channelWidth == 20 && gi == 3200)
+                if (mcs == minMcs && channelWidth == 20 && gi == 3200)
                 {
                     if (throughput * (1 + tolerance) < minExpectedThroughput)
                     {
@@ -572,7 +593,7 @@
                     }
                 }
                 // test last element
-                if (mcs == 11 && channelWidth == 160 && gi == 800)
+                if (mcs == maxMcs && channelWidth == maxChannelWidth && gi == 800)
                 {
                     if (maxExpectedThroughput > 0 &&
                         throughput > maxExpectedThroughput * (1 + tolerance))
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/examples/wireless/wifi-he-network.cc ns-3.42/examples/wireless/wifi-he-network.cc
--- ns-3.41/examples/wireless/wifi-he-network.cc	2024-02-09 14:44:07.841789700 -0800
+++ ns-3.42/examples/wireless/wifi-he-network.cc	2024-05-29 15:29:46.912073100 -0700
@@ -32,7 +32,6 @@
 #include "ns3/on-off-helper.h"
 #include "ns3/packet-sink-helper.h"
 #include "ns3/packet-sink.h"
-#include "ns3/rng-seed-manager.h"
 #include "ns3/spectrum-wifi-helper.h"
 #include "ns3/ssid.h"
 #include "ns3/string.h"
@@ -74,9 +73,9 @@
     bool downlink{true};
     bool useRts{false};
     bool useExtendedBlockAck{false};
-    double simulationTime{10}; // seconds
-    double distance{1.0};      // meters
-    double frequency{5};       // whether 2.4, 5 or 6 GHz
+    Time simulationTime{"10s"};
+    double distance{1.0}; // meters
+    double frequency{5};  // whether 2.4, 5 or 6 GHz
     std::size_t nStations{1};
     std::string dlAckSeqType{"NO-OFDMA"};
     bool enableUlOfdma{false};
@@ -96,7 +95,7 @@
     cmd.AddValue("distance",
                  "Distance in meters between the station and the access point",
                  distance);
-    cmd.AddValue("simulationTime", "Simulation time in seconds", simulationTime);
+    cmd.AddValue("simulationTime", "Simulation time", simulationTime);
     cmd.AddValue("udp", "UDP if set to 1, TCP otherwise", udp);
     cmd.AddValue("downlink",
                  "Generate downlink flows if set to 1, uplink flows otherwise",
@@ -189,9 +188,10 @@
         uint8_t index = 0;
         double previous = 0;
         uint8_t maxChannelWidth = frequency == 2.4 ? 40 : 160;
+        int minGi = enableUlOfdma ? 1600 : 800;
         for (int channelWidth = 20; channelWidth <= maxChannelWidth;) // MHz
         {
-            for (int gi = 3200; gi >= 800;) // Nanoseconds
+            for (int gi = 3200; gi >= minGi;) // Nanoseconds
             {
                 if (!udp)
                 {
@@ -242,8 +242,7 @@
                 }
                 else
                 {
-                    std::cout << "Wrong frequency value!" << std::endl;
-                    return 0;
+                    NS_FATAL_ERROR("Wrong frequency value!");
                 }
 
                 wifi.SetRemoteStationManager("ns3::ConstantRateWifiManager",
@@ -323,8 +322,6 @@
                     apDevice = wifi.Install(phy, mac, wifiApNode);
                 }
 
-                RngSeedManager::SetSeed(1);
-                RngSeedManager::SetRun(1);
                 int64_t streamNumber = 150;
                 streamNumber += wifi.AssignStreams(apDevice, streamNumber);
                 streamNumber += wifi.AssignStreams(staDevices, streamNumber);
@@ -346,6 +343,8 @@
                 InternetStackHelper stack;
                 stack.Install(wifiApNode);
                 stack.Install(wifiStaNodes);
+                streamNumber += stack.AssignStreams(wifiApNode, streamNumber);
+                streamNumber += stack.AssignStreams(wifiStaNodes, streamNumber);
 
                 Ipv4AddressHelper address;
                 address.SetBase("192.168.1.0", "255.255.255.0");
@@ -367,24 +366,30 @@
                     clientNodes.Add(downlink ? wifiApNode.Get(0) : wifiStaNodes.Get(i));
                 }
 
+                const auto maxLoad = HePhy::GetDataRate(mcs, channelWidth, gi, 1) / nStations;
                 if (udp)
                 {
                     // UDP flow
                     uint16_t port = 9;
                     UdpServerHelper server(port);
                     serverApp = server.Install(serverNodes.get());
+                    streamNumber += server.AssignStreams(serverNodes.get(), streamNumber);
+
                     serverApp.Start(Seconds(0.0));
-                    serverApp.Stop(Seconds(simulationTime + 1));
+                    serverApp.Stop(simulationTime + Seconds(1.0));
+                    const auto packetInterval = payloadSize * 8.0 / maxLoad;
 
                     for (std::size_t i = 0; i < nStations; i++)
                     {
                         UdpClientHelper client(serverInterfaces.GetAddress(i), port);
                         client.SetAttribute("MaxPackets", UintegerValue(4294967295U));
-                        client.SetAttribute("Interval", TimeValue(Time("0.00001"))); // packets/s
+                        client.SetAttribute("Interval", TimeValue(Seconds(packetInterval)));
                         client.SetAttribute("PacketSize", UintegerValue(payloadSize));
                         ApplicationContainer clientApp = client.Install(clientNodes.Get(i));
+                        streamNumber += client.AssignStreams(clientNodes.Get(i), streamNumber);
+
                         clientApp.Start(Seconds(1.0));
-                        clientApp.Stop(Seconds(simulationTime + 1));
+                        clientApp.Stop(simulationTime + Seconds(1.0));
                     }
                 }
                 else
@@ -394,8 +399,10 @@
                     Address localAddress(InetSocketAddress(Ipv4Address::GetAny(), port));
                     PacketSinkHelper packetSinkHelper("ns3::TcpSocketFactory", localAddress);
                     serverApp = packetSinkHelper.Install(serverNodes.get());
+                    streamNumber += packetSinkHelper.AssignStreams(serverNodes.get(), streamNumber);
+
                     serverApp.Start(Seconds(0.0));
-                    serverApp.Stop(Seconds(simulationTime + 1));
+                    serverApp.Stop(simulationTime + Seconds(1.0));
 
                     for (std::size_t i = 0; i < nStations; i++)
                     {
@@ -405,27 +412,29 @@
                         onoff.SetAttribute("OffTime",
                                            StringValue("ns3::ConstantRandomVariable[Constant=0]"));
                         onoff.SetAttribute("PacketSize", UintegerValue(payloadSize));
-                        onoff.SetAttribute("DataRate", DataRateValue(1000000000)); // bit/s
+                        onoff.SetAttribute("DataRate", DataRateValue(maxLoad));
                         AddressValue remoteAddress(
                             InetSocketAddress(serverInterfaces.GetAddress(i), port));
                         onoff.SetAttribute("Remote", remoteAddress);
                         ApplicationContainer clientApp = onoff.Install(clientNodes.Get(i));
+                        streamNumber += onoff.AssignStreams(clientNodes.Get(i), streamNumber);
+
                         clientApp.Start(Seconds(1.0));
-                        clientApp.Stop(Seconds(simulationTime + 1));
+                        clientApp.Stop(simulationTime + Seconds(1.0));
                     }
                 }
 
                 Simulator::Schedule(Seconds(0), &Ipv4GlobalRoutingHelper::PopulateRoutingTables);
 
-                Simulator::Stop(Seconds(simulationTime + 1));
+                Simulator::Stop(simulationTime + Seconds(1.0));
                 Simulator::Run();
 
                 // When multiple stations are used, there are chances that association requests
                 // collide and hence the throughput may be lower than expected. Therefore, we relax
                 // the check that the throughput cannot decrease by introducing a scaling factor (or
                 // tolerance)
-                double tolerance = 0.10;
-                uint64_t rxBytes = 0;
+                auto tolerance = 0.10;
+                auto rxBytes = 0.0;
                 if (udp)
                 {
                     for (uint32_t i = 0; i < serverApp.GetN(); i++)
@@ -441,7 +450,7 @@
                         rxBytes += DynamicCast<PacketSink>(serverApp.Get(i))->GetTotalRx();
                     }
                 }
-                double throughput = (rxBytes * 8) / (simulationTime * 1000000.0); // Mbit/s
+                auto throughput = (rxBytes * 8) / simulationTime.GetMicroSeconds(); // Mbit/s
 
                 Simulator::Destroy();
 
@@ -449,7 +458,7 @@
                           << throughput << " Mbit/s" << std::endl;
 
                 // test first element
-                if (mcs == 0 && channelWidth == 20 && gi == 3200)
+                if (mcs == minMcs && channelWidth == 20 && gi == 3200)
                 {
                     if (throughput * (1 + tolerance) < minExpectedThroughput)
                     {
@@ -458,7 +467,7 @@
                     }
                 }
                 // test last element
-                if (mcs == 11 && channelWidth == 160 && gi == 800)
+                if (mcs == maxMcs && channelWidth == maxChannelWidth && gi == 800)
                 {
                     if (maxExpectedThroughput > 0 &&
                         throughput > maxExpectedThroughput * (1 + tolerance))
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/examples/wireless/wifi-ht-network.cc ns-3.42/examples/wireless/wifi-ht-network.cc
--- ns-3.41/examples/wireless/wifi-ht-network.cc	2024-02-09 14:44:07.841789700 -0800
+++ ns-3.42/examples/wireless/wifi-ht-network.cc	2024-05-29 15:29:46.912073100 -0700
@@ -64,14 +64,14 @@
 int
 main(int argc, char* argv[])
 {
-    bool udp = true;
-    bool useRts = false;
-    double simulationTime = 10; // seconds
-    double distance = 1.0;      // meters
-    double frequency = 5.0;     // whether 2.4 or 5.0 GHz
-    int mcs = -1;               // -1 indicates an unset value
-    double minExpectedThroughput = 0;
-    double maxExpectedThroughput = 0;
+    bool udp{true};
+    bool useRts{false};
+    Time simulationTime{"10s"};
+    double distance{1.0}; // meters
+    double frequency{5};  // whether 2.4 or 5 GHz
+    int mcs{-1};          // -1 indicates an unset value
+    double minExpectedThroughput{0.0};
+    double maxExpectedThroughput{0.0};
 
     CommandLine cmd(__FILE__);
     cmd.AddValue("frequency",
@@ -80,7 +80,7 @@
     cmd.AddValue("distance",
                  "Distance in meters between the station and the access point",
                  distance);
-    cmd.AddValue("simulationTime", "Simulation time in seconds", simulationTime);
+    cmd.AddValue("simulationTime", "Simulation time", simulationTime);
     cmd.AddValue("udp", "UDP if set to 1, TCP otherwise", udp);
     cmd.AddValue("useRts", "Enable/disable RTS/CTS", useRts);
     cmd.AddValue("mcs", "if set, limit testing to a specific MCS (0-7)", mcs);
@@ -159,8 +159,7 @@
                 }
                 else
                 {
-                    std::cout << "Wrong frequency value!" << std::endl;
-                    return 0;
+                    NS_FATAL_ERROR("Wrong frequency value!");
                 }
 
                 auto nonHtRefRateMbps = HtPhy::GetNonHtReferenceRate(mcs) / 1e6;
@@ -197,6 +196,10 @@
                 NetDeviceContainer apDevice;
                 apDevice = wifi.Install(phy, mac, wifiApNode);
 
+                int64_t streamNumber = 150;
+                streamNumber += wifi.AssignStreams(apDevice, streamNumber);
+                streamNumber += wifi.AssignStreams(staDevice, streamNumber);
+
                 // mobility.
                 MobilityHelper mobility;
                 Ptr<ListPositionAllocator> positionAlloc = CreateObject<ListPositionAllocator>();
@@ -214,6 +217,8 @@
                 InternetStackHelper stack;
                 stack.Install(wifiApNode);
                 stack.Install(wifiStaNode);
+                streamNumber += stack.AssignStreams(wifiApNode, streamNumber);
+                streamNumber += stack.AssignStreams(wifiStaNode, streamNumber);
 
                 Ipv4AddressHelper address;
                 address.SetBase("192.168.1.0", "255.255.255.0");
@@ -224,6 +229,7 @@
                 apNodeInterface = address.Assign(apDevice);
 
                 /* Setting applications */
+                const auto maxLoad = HtPhy::GetDataRate(mcs, channelWidth, sgi ? 400 : 800, 1);
                 ApplicationContainer serverApp;
                 if (udp)
                 {
@@ -231,16 +237,21 @@
                     uint16_t port = 9;
                     UdpServerHelper server(port);
                     serverApp = server.Install(wifiStaNode.Get(0));
+                    streamNumber += server.AssignStreams(wifiStaNode.Get(0), streamNumber);
+
                     serverApp.Start(Seconds(0.0));
-                    serverApp.Stop(Seconds(simulationTime + 1));
+                    serverApp.Stop(simulationTime + Seconds(1.0));
+                    const auto packetInterval = payloadSize * 8.0 / maxLoad;
 
                     UdpClientHelper client(staNodeInterface.GetAddress(0), port);
                     client.SetAttribute("MaxPackets", UintegerValue(4294967295U));
-                    client.SetAttribute("Interval", TimeValue(Time("0.00001"))); // packets/s
+                    client.SetAttribute("Interval", TimeValue(Seconds(packetInterval)));
                     client.SetAttribute("PacketSize", UintegerValue(payloadSize));
                     ApplicationContainer clientApp = client.Install(wifiApNode.Get(0));
+                    streamNumber += client.AssignStreams(wifiApNode.Get(0), streamNumber);
+
                     clientApp.Start(Seconds(1.0));
-                    clientApp.Stop(Seconds(simulationTime + 1));
+                    clientApp.Stop(simulationTime + Seconds(1.0));
                 }
                 else
                 {
@@ -249,8 +260,11 @@
                     Address localAddress(InetSocketAddress(Ipv4Address::GetAny(), port));
                     PacketSinkHelper packetSinkHelper("ns3::TcpSocketFactory", localAddress);
                     serverApp = packetSinkHelper.Install(wifiStaNode.Get(0));
+                    streamNumber +=
+                        packetSinkHelper.AssignStreams(wifiStaNode.Get(0), streamNumber);
+
                     serverApp.Start(Seconds(0.0));
-                    serverApp.Stop(Seconds(simulationTime + 1));
+                    serverApp.Stop(simulationTime + Seconds(1.0));
 
                     OnOffHelper onoff("ns3::TcpSocketFactory", Ipv4Address::GetAny());
                     onoff.SetAttribute("OnTime",
@@ -258,21 +272,23 @@
                     onoff.SetAttribute("OffTime",
                                        StringValue("ns3::ConstantRandomVariable[Constant=0]"));
                     onoff.SetAttribute("PacketSize", UintegerValue(payloadSize));
-                    onoff.SetAttribute("DataRate", DataRateValue(200000000)); // bit/s
+                    onoff.SetAttribute("DataRate", DataRateValue(maxLoad));
                     AddressValue remoteAddress(
                         InetSocketAddress(staNodeInterface.GetAddress(0), port));
                     onoff.SetAttribute("Remote", remoteAddress);
                     ApplicationContainer clientApp = onoff.Install(wifiApNode.Get(0));
+                    streamNumber += onoff.AssignStreams(wifiApNode.Get(0), streamNumber);
+
                     clientApp.Start(Seconds(1.0));
-                    clientApp.Stop(Seconds(simulationTime + 1));
+                    clientApp.Stop(simulationTime + Seconds(1.0));
                 }
 
                 Ipv4GlobalRoutingHelper::PopulateRoutingTables();
 
-                Simulator::Stop(Seconds(simulationTime + 1));
+                Simulator::Stop(simulationTime + Seconds(1.0));
                 Simulator::Run();
 
-                uint64_t rxBytes = 0;
+                auto rxBytes = 0.0;
                 if (udp)
                 {
                     rxBytes = payloadSize * DynamicCast<UdpServer>(serverApp.Get(0))->GetReceived();
@@ -281,7 +297,7 @@
                 {
                     rxBytes = DynamicCast<PacketSink>(serverApp.Get(0))->GetTotalRx();
                 }
-                double throughput = (rxBytes * 8) / (simulationTime * 1000000.0); // Mbit/s
+                auto throughput = (rxBytes * 8) / simulationTime.GetMicroSeconds(); // Mbit/s
 
                 Simulator::Destroy();
 
@@ -289,7 +305,7 @@
                           << sgi << "\t\t\t" << throughput << " Mbit/s" << std::endl;
 
                 // test first element
-                if (mcs == 0 && channelWidth == 20 && !sgi)
+                if (mcs == minMcs && channelWidth == 20 && !sgi)
                 {
                     if (throughput < minExpectedThroughput)
                     {
@@ -297,7 +313,7 @@
                     }
                 }
                 // test last element
-                if (mcs == 7 && channelWidth == 40 && sgi)
+                if (mcs == maxMcs && channelWidth == 40 && sgi)
                 {
                     if (maxExpectedThroughput > 0 && throughput > maxExpectedThroughput)
                     {
